#include <windows.h>
#include <stdio.h>
#include <locale.h>
#include <mbstring.h>
#include <Aclapi.h>
#include <Sddl.h>
#include "tlhelp32.h"
#include <Ntsecapi.h>
#include <ras.h>

#define pusherr {DWORD __err = GetLastError();{
#define poperr  }SetLastError(__err);}
#define emsgbycode( errcode, pmsg ) pusherr; FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS, NULL, errcode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)(&(pmsg)), 0, NULL ); poperr;
#define emsg( pmsg ) emsgbycode( GetLastError(), pmsg )
#define ntemsg( status, pmsg ) pusherr;FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS|FORMAT_MESSAGE_FROM_HMODULE, GetModuleHandleA("NTDLL.DLL"), status, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)(&(pmsg)), 0, NULL );poperr;
#define msgalloc        {char * pmsg; emsg(pmsg);{
#define msgfree         }LocalFree( pmsg );}
#define ntmsgalloc(nts)   {char * pmsg; ntemsg(nts,pmsg);{
#define ntmsgfree         }LocalFree( pmsg );}

#define LSA_ACCESS_DENIED 0xc0000022
#define LSA_NO_NAME       0xc0000034

DWORD ProcessNameToId( PCSTR pszProcessName );
BOOL EnablePrivilege( PCSTR pszPrivilegeName ) ;

BOOL gbBin = FALSE;
BOOL gbShowAll = FALSE;

BOOL DumpBinaryData( PVOID pFrom, DWORD length )
{
typedef unsigned __int64 U64;
#define LALIGN16(d) (d-d%16)
/*
00e70030: 77 6f 72 6b 5c 52 65 6d 6f 74 65 46 75 6e 63 2e   work\RemoteFunc.
*/
#define PRESET_LINE_CONTENT \
": -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --   ................\n"

	BOOL bSuccess = TRUE;
	char szLine[160];
	PSTR pszBin = &szLine[10];
	PSTR pszTxt = &szLine[60];
    DWORD n;

	for( n = 0; n < length; n+=16 )
	{
		int i;
		int _f,_t;
		unsigned char uchar16[16];

		sprintf( szLine, "%08x" PRESET_LINE_CONTENT, (DWORD)n );

		_f = 0;
		_t = 16;
		if( length-n<16 ) 
			_t = (int)(length%16);

        memcpy( &uchar16[_f], (PVOID)((U64)pFrom + n), _t-_f );

		for( i=_f; i<_t; i++ ) 
			_snprintf( &pszBin[3*i], 3, "%02x ", uchar16[i] );

		for( i = _f; i < _t; i++ ){
			if( uchar16[i] && isprint( uchar16[i] ) )
				pszTxt[i] = uchar16[i]=='\t'?' ':uchar16[i];
		}

		printf( "%s", szLine );
	}

	return bSuccess;
}

BOOL ShowPrivateData( LSA_HANDLE lsa, PCSTR _pszKeyName )
{
    BOOL bSuccess = FALSE;
    LONG nts;
    WCHAR szKeyName[1024] = {0};
    LSA_UNICODE_STRING * pusPrivateData;
    LSA_UNICODE_STRING usKeyName = {0};

    MultiByteToWideChar( 0,0, _pszKeyName, -1, szKeyName, sizeof(szKeyName)/2-1 );
    usKeyName.Length = wcslen(szKeyName)*sizeof(WCHAR);
    usKeyName.MaximumLength = usKeyName.Length+sizeof(WCHAR);
    usKeyName.Buffer = szKeyName;

    if( gbShowAll ){
        printf( "\nkey [%S]\n", szKeyName );
    }
    nts = LsaRetrievePrivateData( lsa, &usKeyName, &pusPrivateData );
    if( nts >= 0 )
    {
        if( ! gbShowAll ){
            printf( "\nkey [%S]\n", szKeyName );
        }
        if( gbBin || gbShowAll )
        {
            printf( "----------------------------begin binary output-------------------------------\n" );
            DumpBinaryData( pusPrivateData->Buffer, pusPrivateData->Length );
            printf( "----------------------------end   binary output-------------------------------\n" );
        }

        if( ! gbBin || gbShowAll )
        {
            DWORD i, __i;
            printf( "----------------------------begin string output-------------------------------\n" );
            __i = 0;
            for( i = 0; i < (DWORD)pusPrivateData->Length/2; i++ )
            {
                if( ! pusPrivateData->Buffer[i] )
                {
                    if( pusPrivateData->Buffer[__i] )
                        printf( "%S\n", &pusPrivateData->Buffer[__i] );
                    __i = i+1;
                }
            }
            if( __i < (DWORD)pusPrivateData->Length/2 ){
                if( pusPrivateData->Buffer[__i] )
                    printf( "%S\n", &pusPrivateData->Buffer[__i] );
            }
            printf( "----------------------------end   string output-------------------------------\n" );
        }

        LsaFreeMemory( pusPrivateData );

        bSuccess = TRUE;
    }
    else{
        if( nts == LSA_NO_NAME ){
        }
        else
        if( nts = LSA_ACCESS_DENIED ){
            if( gbShowAll )
                printf( "Access denied\n" );
        }
        else{
            ntmsgalloc( nts );
            fprintf( stderr, "LsaRetrievePrivateData Error 0x%08x: %s", nts, pmsg );
            ntmsgfree;
        }
    }

    return bSuccess;
}

LONG WINAPI MyNtImpersonateThread(
    HANDLE ImpersonatingThreadHandle, 
    HANDLE ImpersonatedThreadHandle )
{
    static LONG (WINAPI *pNtImpersonateThread)(
        HANDLE ImpersonatingThreadHandle, 
        HANDLE ImpersonatedThreadHandle, 
        PSECURITY_QUALITY_OF_SERVICE pQoS) = NULL;
    static SECURITY_QUALITY_OF_SERVICE QoS =
    {sizeof(QoS), DEFAULT_IMPERSONATION_LEVEL, SECURITY_DYNAMIC_TRACKING, FALSE};

    if( ! pNtImpersonateThread ){
        *(PVOID*)&pNtImpersonateThread = (PVOID)GetProcAddress( GetModuleHandle("NTDLL"), "NtImpersonateThread" );
    }
    return  pNtImpersonateThread(
            ImpersonatingThreadHandle, 
            ImpersonatedThreadHandle, 
            &QoS);
}

BOOL ImpersonateLSA()
{
    BOOL bSuccess = FALSE;
    HANDLE hSnap;
    PROCESSENTRY32 pe      = {0};

    EnablePrivilege( SE_DEBUG_NAME );
/*
    {
    HANDLE hProcess;
    DWORD  pid;

    pid = ProcessNameToId( "lsass.exe" );
    hProcess = OpenProcess( MAXIMUM_ALLOWED, 0, pid );
    if( hProcess )
    {
        HANDLE hToken;
        if( OpenProcessToken( hProcess, MAXIMUM_ALLOWED, &hToken ) )
        {
            HANDLE hDup;

            if( DuplicateHandle( GetCurrentProcess(),hToken,
                        GetCurrentProcess(), &hDup, access,0,0 ) )
            {
                if( ImpersonateLoggedOnUser( hDup ) )
                    bSuccess = TRUE;
                else{
                    msgalloc;
                    fprintf( stderr, "ImpersonateLoggedOnUser Error %d: %s", GetLastError(), pmsg );
                    msgfree;
                }
                CloseHandle( hDup );
            }

            CloseHandle( hToken );
        }
        CloseHandle( hProcess );
    }
    return bSuccess;
    }
*/
    hSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS|TH32CS_SNAPTHREAD, 0 );
    if( hSnap != INVALID_HANDLE_VALUE )
    {
        pe.dwSize = sizeof(PROCESSENTRY32); 
        if( Process32First( hSnap, &pe ) ) 
        {
            do
            {
                if( strcmpi( pe.szExeFile, "lsass.exe" ) == 0 )
                {
                    THREADENTRY32 te = {0};

                    te.dwSize = sizeof(THREADENTRY32);
                    if( Thread32First( hSnap, &te ) )
                    {
                        do
                        {
                            if( te.th32OwnerProcessID == pe.th32ProcessID )
                            {
                                HANDLE hThread;
                                hThread = OpenThread( MAXIMUM_ALLOWED, 0, te.th32ThreadID );
                                if( hThread )
                                {
                                    LONG nts = MyNtImpersonateThread( GetCurrentThread(), hThread );
                                    if( nts < 0 ){
                                        ntmsgalloc( nts );
                                        fprintf( stderr, "NtImpersonateThread ErrorStatus 0x%08x: %s", nts, pmsg );
                                        ntmsgfree;
                                    }
                                    else{
                                        //printf( "Impersonate OK\n" );
                                        bSuccess = TRUE;
                                    }
                                    CloseHandle( hThread );
                                }
                                else{
                                    msgalloc;
                                    fprintf( stderr, "OpenThread(%d) Error %d: %s", te.th32ThreadID, GetLastError(), pmsg );
                                    msgfree;
                                }

                                break;
                            }
                        }
                        while( Thread32Next( hSnap, &te ) );
                    }

                    break;
                }
            }
            while( Process32Next( hSnap, &pe ) );
        }
        CloseHandle( hSnap );
    }

    return bSuccess;
}

typedef BOOL (WINAPI*ENUM_LSA_SECRET_CALLBACK)( PVOID callback_param, PCSTR pszKeyName );

BOOL EnumLsaSecret( 
    ENUM_LSA_SECRET_CALLBACK callback,
    PVOID callback_param
    )
{
    BOOL bSuccess = TRUE;

    if( ImpersonateLSA())
    {
        HKEY hKey;
        if( 0==RegOpenKeyEx( HKEY_LOCAL_MACHINE, 
                "SECURITY\\Policy\\Secrets", 0,
                KEY_READ, &hKey ) )
        {
            char szSubKeyName[1024] = {0};
            DWORD cbSubKeyName;

            bSuccess = TRUE;

            cbSubKeyName = sizeof(szSubKeyName)-1;
            if( 0==RegEnumKeyEx( hKey, 0, 
                szSubKeyName, &cbSubKeyName, 0, 0, 0, 0 ))
            {
                BOOL bContinue;
                DWORD index;

                bContinue = callback( callback_param, szSubKeyName );

                for( index = 1; bContinue; index++ )
                {
                    LONG result;
                    memset( szSubKeyName, 0, sizeof(szSubKeyName) );
                    cbSubKeyName = sizeof(szSubKeyName)-1;

                    result = RegEnumKeyEx( hKey, index, 
                                szSubKeyName, &cbSubKeyName, 0, 0, 0, 0 );
                    if( result == 0 )
                    {
                        bContinue = callback( callback_param, szSubKeyName );
                    }
                    else if( result == ERROR_NO_MORE_ITEMS )
                        break;
                }
            }

            RegCloseKey( hKey );
        }

        RevertToSelf();
    }

    return bSuccess;
}

BOOL WINAPI Callback_DisplayAllLsaSecret( PVOID callback_param, PCSTR pszKeyName )
{
    LSA_OBJECT_ATTRIBUTES oa = {0};
    LSA_HANDLE lsa;
    LONG nts;

    nts = LsaOpenPolicy( 0, &oa, MAXIMUM_ALLOWED, &lsa );
    if( nts >= 0 )
    {
        ShowPrivateData( lsa, pszKeyName );
        LsaClose( lsa );
    }
    else{
        ntmsgalloc( nts );
        fprintf( stderr, "LsaOpenPolicy Error 0x%08x: %s", nts, pmsg );
        ntmsgfree;
    }

    return TRUE;
}

DWORD ProcessNameToId( PCSTR pszProcessName )
{
	HANDLE hSnap;
	PROCESSENTRY32 pe      = {0};
	
	hSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 );
	if( hSnap != INVALID_HANDLE_VALUE )
	{
		pe.dwSize = sizeof(PROCESSENTRY32); 
		if( Process32First( hSnap, &pe ) ) 
		{
			do
			{
				char szTmp[128] = {0};
				unsigned char * p;

				if( strcmpi( pe.szExeFile, pszProcessName ) == 0 )
					return pe.th32ProcessID;

				p = _mbsrchr( (unsigned char*)pe.szExeFile, '.' );
				if( p )
				{
					strncpy( szTmp, pe.szExeFile, p-pe.szExeFile );
					if( strcmpi( szTmp, pszProcessName ) == 0 )
						return pe.th32ProcessID;
				}
			}
			while( Process32Next( hSnap, &pe ) );
		}
		CloseHandle( hSnap );
	}
	return 0;
}

BOOL EnablePrivilege( PCSTR pszPrivilegeName ) 
{
    BOOL bSuccess = FALSE;
    HANDLE hToken;

    if( OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken ) )
    {
        TOKEN_PRIVILEGES tp;
        LUID luid;

        if( LookupPrivilegeValue(NULL, pszPrivilegeName, &luid ) )
        {
            tp.PrivilegeCount = 1;
            tp.Privileges[0].Luid = luid;
            tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

            if( AdjustTokenPrivileges( hToken, FALSE, &tp, sizeof(tp), NULL, NULL )
                && GetLastError() == ERROR_SUCCESS )
            { 
                bSuccess = TRUE;
            }
        }

        pusherr;
        CloseHandle(hToken);
        poperr;
    }
    return bSuccess;
}

int main( int argc, char ** argv )
{
    setlocale( LC_ALL, "" );

    if( argc == 2 && strcmp( argv[1], "/?" )==0 )
        goto usage;

    if( argc == 2 && strcmpi( argv[1], "/b" )==0 )
        gbBin = TRUE;

    if( argc == 2 && strcmpi( argv[1], "/a" )==0 )
        gbShowAll = TRUE;

    if( ! EnumLsaSecret( Callback_DisplayAllLsaSecret, NULL ) )
    {
        msgalloc;
        fprintf( stderr, "Error: %s", GetLastError(), pmsg );
        msgfree;
    }

    return 0;
usage:
    {
    char * p = (char*)_mbsrchr( argv[0], '\\' );
    if( p ) p++;
    else p=argv[0];

    fprintf( stderr, 
        "----------------------- LSA Secret utility usage -------------------------\n"
        "  %s       (string output)\n" 
        "  %s /b    (binary output)\n" 
        "  %s /a    (output all detail output)\n" 
        ,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p,p
        );
    }
    return 0;
}

